// Package v2 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.8.2 DO NOT EDIT.
package v2

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
)

const (
	BearerScopes = "Bearer.Scopes"
)

// Defines values for BlueprintCustomizationsPartitioningMode.
const (
	BlueprintCustomizationsPartitioningModeAutoLvm BlueprintCustomizationsPartitioningMode = "auto-lvm"

	BlueprintCustomizationsPartitioningModeLvm BlueprintCustomizationsPartitioningMode = "lvm"

	BlueprintCustomizationsPartitioningModeRaw BlueprintCustomizationsPartitioningMode = "raw"
)

// Defines values for ComposeStatusValue.
const (
	ComposeStatusValueFailure ComposeStatusValue = "failure"

	ComposeStatusValuePending ComposeStatusValue = "pending"

	ComposeStatusValueSuccess ComposeStatusValue = "success"
)

// Defines values for CustomizationsPartitioningMode.
const (
	CustomizationsPartitioningModeAutoLvm CustomizationsPartitioningMode = "auto-lvm"

	CustomizationsPartitioningModeLvm CustomizationsPartitioningMode = "lvm"

	CustomizationsPartitioningModeRaw CustomizationsPartitioningMode = "raw"
)

// Defines values for ImageSBOMPipelinePurpose.
const (
	ImageSBOMPipelinePurposeBuildroot ImageSBOMPipelinePurpose = "buildroot"

	ImageSBOMPipelinePurposeImage ImageSBOMPipelinePurpose = "image"
)

// Defines values for ImageSBOMSbomType.
const (
	ImageSBOMSbomTypeSpdx ImageSBOMSbomType = "spdx"
)

// Defines values for ImageStatusValue.
const (
	ImageStatusValueBuilding ImageStatusValue = "building"

	ImageStatusValueFailure ImageStatusValue = "failure"

	ImageStatusValuePending ImageStatusValue = "pending"

	ImageStatusValueRegistering ImageStatusValue = "registering"

	ImageStatusValueSuccess ImageStatusValue = "success"

	ImageStatusValueUploading ImageStatusValue = "uploading"
)

// Defines values for ImageTypes.
const (
	ImageTypesAws ImageTypes = "aws"

	ImageTypesAwsHaRhui ImageTypes = "aws-ha-rhui"

	ImageTypesAwsRhui ImageTypes = "aws-rhui"

	ImageTypesAwsSapRhui ImageTypes = "aws-sap-rhui"

	ImageTypesAzure ImageTypes = "azure"

	ImageTypesAzureEap7Rhui ImageTypes = "azure-eap7-rhui"

	ImageTypesAzureRhui ImageTypes = "azure-rhui"

	ImageTypesAzureSapRhui ImageTypes = "azure-sap-rhui"

	ImageTypesEdgeCommit ImageTypes = "edge-commit"

	ImageTypesEdgeContainer ImageTypes = "edge-container"

	ImageTypesEdgeInstaller ImageTypes = "edge-installer"

	ImageTypesGcp ImageTypes = "gcp"

	ImageTypesGcpRhui ImageTypes = "gcp-rhui"

	ImageTypesGuestImage ImageTypes = "guest-image"

	ImageTypesImageInstaller ImageTypes = "image-installer"

	ImageTypesIotBootableContainer ImageTypes = "iot-bootable-container"

	ImageTypesIotCommit ImageTypes = "iot-commit"

	ImageTypesIotContainer ImageTypes = "iot-container"

	ImageTypesIotInstaller ImageTypes = "iot-installer"

	ImageTypesIotRawImage ImageTypes = "iot-raw-image"

	ImageTypesIotSimplifiedInstaller ImageTypes = "iot-simplified-installer"

	ImageTypesLiveInstaller ImageTypes = "live-installer"

	ImageTypesMinimalRaw ImageTypes = "minimal-raw"

	ImageTypesOci ImageTypes = "oci"

	ImageTypesVsphere ImageTypes = "vsphere"

	ImageTypesVsphereOva ImageTypes = "vsphere-ova"

	ImageTypesWsl ImageTypes = "wsl"
)

// Defines values for UploadStatusValue.
const (
	UploadStatusValueFailure UploadStatusValue = "failure"

	UploadStatusValuePending UploadStatusValue = "pending"

	UploadStatusValueRunning UploadStatusValue = "running"

	UploadStatusValueSuccess UploadStatusValue = "success"
)

// Defines values for UploadTypes.
const (
	UploadTypesAws UploadTypes = "aws"

	UploadTypesAwsS3 UploadTypes = "aws.s3"

	UploadTypesAzure UploadTypes = "azure"

	UploadTypesContainer UploadTypes = "container"

	UploadTypesGcp UploadTypes = "gcp"

	UploadTypesLocal UploadTypes = "local"

	UploadTypesOciObjectstorage UploadTypes = "oci.objectstorage"

	UploadTypesPulpOstree UploadTypes = "pulp.ostree"
)

// AWSEC2CloneCompose defines model for AWSEC2CloneCompose.
type AWSEC2CloneCompose struct {
	Region            string    `json:"region"`
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// AWSEC2UploadOptions defines model for AWSEC2UploadOptions.
type AWSEC2UploadOptions struct {
	Region            string   `json:"region"`
	ShareWithAccounts []string `json:"share_with_accounts"`
	SnapshotName      *string  `json:"snapshot_name,omitempty"`
}

// AWSEC2UploadStatus defines model for AWSEC2UploadStatus.
type AWSEC2UploadStatus struct {
	Ami    string `json:"ami"`
	Region string `json:"region"`
}

// AWSS3UploadOptions defines model for AWSS3UploadOptions.
type AWSS3UploadOptions struct {
	// If set to false (the default value), a long, obfuscated URL
	// is returned. Its expiration might be sooner than for other upload
	// targets.
	//
	// If set to true, a shorter URL is returned and
	// its expiration is the same as for the other upload targets.
	Public *bool  `json:"public,omitempty"`
	Region string `json:"region"`
}

// AWSS3UploadStatus defines model for AWSS3UploadStatus.
type AWSS3UploadStatus struct {
	Url string `json:"url"`
}

// AzureUploadOptions defines model for AzureUploadOptions.
type AzureUploadOptions struct {
	// Name of the uploaded image. It must be unique in the given resource group.
	// If name is omitted from the request, a random one based on a UUID is
	// generated.
	ImageName *string `json:"image_name,omitempty"`

	// Location of the provided resource_group, where the image should be uploaded and registered.
	// How to list all locations:
	// https://docs.microsoft.com/en-us/cli/azure/account?view=azure-cli-latest#az_account_list_locations'
	// If the location is not specified, it is deducted from the provided resource_group.
	Location *string `json:"location,omitempty"`

	// Name of the resource group where the image should be uploaded.
	ResourceGroup string `json:"resource_group"`

	// ID of subscription where the image should be uploaded.
	SubscriptionId string `json:"subscription_id"`

	// ID of the tenant where the image should be uploaded.
	// How to find it in the Azure Portal:
	// https://docs.microsoft.com/en-us/azure/active-directory/fundamentals/active-directory-how-to-find-tenant
	TenantId string `json:"tenant_id"`
}

// AzureUploadStatus defines model for AzureUploadStatus.
type AzureUploadStatus struct {
	ImageName string `json:"image_name"`
}

// Blueprint defines model for Blueprint.
type Blueprint struct {
	// Container images to embed into the final artfact
	Containers     *[]Container             `json:"containers,omitempty"`
	Customizations *BlueprintCustomizations `json:"customizations,omitempty"`
	Description    *string                  `json:"description,omitempty"`

	// The distribution to use for the compose. If left empty the host
	// distro will be used.
	Distro *string `json:"distro,omitempty"`

	// Package groups to be installed
	Groups *[]PackageGroup `json:"groups,omitempty"`

	// An alias for packages, retained for backwards compatability
	Modules *[]Package `json:"modules,omitempty"`
	Name    string     `json:"name"`

	// Packages to be installed
	Packages *[]Package `json:"packages,omitempty"`

	// A semver version number
	Version *string `json:"version,omitempty"`
}

// BlueprintCustomizations defines model for BlueprintCustomizations.
type BlueprintCustomizations struct {
	// Directories to create in the final artifact
	Directories *[]Directory `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo *FDO `json:"fdo,omitempty"`

	// Files to create in the final artifact
	Files *[]BlueprintFile `json:"files,omitempty"`

	// List of filesystem mountpoints to create
	Filesystem *[]BlueprintFilesystem `json:"filesystem,omitempty"`

	// Enable FIPS mode
	Fips *bool `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *BlueprintFirewall `json:"firewall,omitempty"`

	// List of groups to create
	Group *[]Group `json:"group,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale            `json:"locale,omitempty"`
	Openscap *BlueprintOpenSCAP `json:"openscap,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *BlueprintCustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Repositories to write to /etc/yum.repos.d/ in the final image. Note
	// that these are not used at build time.
	Repositories *[]BlueprintRepository `json:"repositories,omitempty"`
	Rhsm         *RHSMCustomization     `json:"rhsm,omitempty"`
	Rpm          *RPMCustomization      `json:"rpm,omitempty"`
	Services     *Services              `json:"services,omitempty"`

	// List of ssh keys
	Sshkey *[]SSHKey `json:"sshkey,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`

	// List of users to create
	User *[]BlueprintUser `json:"user,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type BlueprintCustomizationsPartitioningMode string

// A custom file to create in the final artifact.
type BlueprintFile struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// BlueprintFilesystem defines model for BlueprintFilesystem.
type BlueprintFilesystem struct {
	// size of the filesystem in bytes
	Minsize    uint64 `json:"minsize"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type BlueprintFirewall struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
	Zones    *[]FirewallZones  `json:"zones,omitempty"`
}

// BlueprintOpenSCAP defines model for BlueprintOpenSCAP.
type BlueprintOpenSCAP struct {
	Datastream    *string                `json:"datastream,omitempty"`
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// BlueprintRepository defines model for BlueprintRepository.
type BlueprintRepository struct {
	Baseurls   *[]string `json:"baseurls,omitempty"`
	Enabled    *bool     `json:"enabled,omitempty"`
	Filename   *string   `json:"filename,omitempty"`
	Gpgcheck   *bool     `json:"gpgcheck,omitempty"`
	Gpgkeys    *[]string `json:"gpgkeys,omitempty"`
	Id         string    `json:"id"`
	Metalink   *string   `json:"metalink,omitempty"`
	Mirrorlist *string   `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool   `json:"module_hotfixes,omitempty"`
	Name           *string `json:"name,omitempty"`
	Priority       *int    `json:"priority,omitempty"`
	RepoGpgcheck   *bool   `json:"repo_gpgcheck,omitempty"`
	Sslverify      *bool   `json:"sslverify,omitempty"`
}

// BlueprintUser defines model for BlueprintUser.
type BlueprintUser struct {
	Description *string `json:"description,omitempty"`

	// Group id to use instead of the default
	Gid *int `json:"gid,omitempty"`

	// A list of additional groups to add the user to
	Groups *[]string `json:"groups,omitempty"`

	// The user's home directory
	Home *string `json:"home,omitempty"`

	// ssh public key
	Key  *string `json:"key,omitempty"`
	Name string  `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`

	// Login shell to use
	Shell *string `json:"shell,omitempty"`

	// User id to use instead of the default
	Uid *int `json:"uid,omitempty"`
}

// CloneComposeBody defines model for CloneComposeBody.
type CloneComposeBody interface{}

// CloneComposeResponse defines model for CloneComposeResponse.
type CloneComposeResponse struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// CloneStatus defines model for CloneStatus.
type CloneStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded struct due to allOf(#/components/schemas/UploadStatus)
	UploadStatus `yaml:",inline"`
}

// ComposeId defines model for ComposeId.
type ComposeId struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// ComposeLogs defines model for ComposeLogs.
type ComposeLogs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageBuilds []interface{} `json:"image_builds"`
	Koji        *KojiLogs     `json:"koji,omitempty"`
}

// ComposeManifests defines model for ComposeManifests.
type ComposeManifests struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Manifests []interface{} `json:"manifests"`
}

// ComposeMetadata defines model for ComposeMetadata.
type ComposeMetadata struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// ID (hash) of the built commit
	OstreeCommit *string `json:"ostree_commit,omitempty"`

	// Package list including NEVRA
	Packages *[]PackageMetadata `json:"packages,omitempty"`
}

// ComposeRequest defines model for ComposeRequest.
type ComposeRequest struct {
	Blueprint      *Blueprint      `json:"blueprint,omitempty"`
	Customizations *Customizations `json:"customizations,omitempty"`
	Distribution   string          `json:"distribution"`
	ImageRequest   *ImageRequest   `json:"image_request,omitempty"`
	ImageRequests  *[]ImageRequest `json:"image_requests,omitempty"`
	Koji           *Koji           `json:"koji,omitempty"`
}

// ComposeSBOMs defines model for ComposeSBOMs.
type ComposeSBOMs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// The SBOM documents for each image built in the compose.
	Items [][]ImageSBOM `json:"items"`
}

// ComposeStatus defines model for ComposeStatus.
type ComposeStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageStatus   ImageStatus        `json:"image_status"`
	ImageStatuses *[]ImageStatus     `json:"image_statuses,omitempty"`
	KojiStatus    *KojiStatus        `json:"koji_status,omitempty"`
	Status        ComposeStatusValue `json:"status"`
}

// ComposeStatusError defines model for ComposeStatusError.
type ComposeStatusError struct {
	Details *interface{} `json:"details,omitempty"`
	Id      int          `json:"id"`
	Reason  string       `json:"reason"`
}

// ComposeStatusValue defines model for ComposeStatusValue.
type ComposeStatusValue string

// Container defines model for Container.
type Container struct {
	// Name to use for the container from the image
	Name *string `json:"name,omitempty"`

	// Reference to the container to embed
	Source string `json:"source"`

	// Control TLS verifification
	TlsVerify *bool `json:"tls_verify,omitempty"`
}

// ContainerUploadOptions defines model for ContainerUploadOptions.
type ContainerUploadOptions struct {
	// Name for the created container image
	Name *string `json:"name,omitempty"`

	// Tag for the created container image
	Tag *string `json:"tag,omitempty"`
}

// ContainerUploadStatus defines model for ContainerUploadStatus.
type ContainerUploadStatus struct {
	// Digest of the manifest of the uploaded container on the registry
	Digest string `json:"digest"`

	// FQDN of the uploaded image
	Url string `json:"url"`
}

// CustomRepository defines model for CustomRepository.
type CustomRepository struct {
	Baseurl        *[]string `json:"baseurl,omitempty"`
	CheckGpg       *bool     `json:"check_gpg,omitempty"`
	CheckRepoGpg   *bool     `json:"check_repo_gpg,omitempty"`
	Enabled        *bool     `json:"enabled,omitempty"`
	Filename       *string   `json:"filename,omitempty"`
	Gpgkey         *[]string `json:"gpgkey,omitempty"`
	Id             string    `json:"id"`
	Metalink       *string   `json:"metalink,omitempty"`
	Mirrorlist     *string   `json:"mirrorlist,omitempty"`
	ModuleHotfixes *bool     `json:"module_hotfixes,omitempty"`
	Name           *string   `json:"name,omitempty"`
	Priority       *int      `json:"priority,omitempty"`
	SslVerify      *bool     `json:"ssl_verify,omitempty"`
}

// Customizations defines model for Customizations.
type Customizations struct {
	Containers *[]Container `json:"containers,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will be used to depsolve and retrieve packages. Additionally,
	// these packages will be saved and imported to the `/etc/yum.repos.d/` directory
	// on the image
	CustomRepositories *[]CustomRepository `json:"custom_repositories,omitempty"`
	Directories        *[]Directory        `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo        *FDO          `json:"fdo,omitempty"`
	Files      *[]File       `json:"files,omitempty"`
	Filesystem *[]Filesystem `json:"filesystem,omitempty"`

	// System FIPS mode setup
	Fips *FIPS `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *FirewallCustomization `json:"firewall,omitempty"`

	// List of groups to create
	Groups *[]Group `json:"groups,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale   `json:"locale,omitempty"`
	Openscap *OpenSCAP `json:"openscap,omitempty"`
	Packages *[]string `json:"packages,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *CustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will only be used to depsolve and retrieve packages
	// for the OS itself (they will not be available for the build root or
	// any other part of the build process). The package_sets field for these
	// repositories is ignored.
	PayloadRepositories *[]Repository      `json:"payload_repositories,omitempty"`
	Rhsm                *RHSMCustomization `json:"rhsm,omitempty"`
	Rpm                 *RPMCustomization  `json:"rpm,omitempty"`
	Services            *Services          `json:"services,omitempty"`
	Subscription        *Subscription      `json:"subscription,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`
	Users    *[]User   `json:"users,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type CustomizationsPartitioningMode string

// DNFPluginConfig defines model for DNFPluginConfig.
type DNFPluginConfig struct {
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom directory to create in the final artifact.
type Directory struct {
	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the directory as a group name or a gid
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the directory in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the directory
	Path string `json:"path"`

	// Owner of the directory as a user name or a uid
	User *interface{} `json:"user,omitempty"`
}

// Error defines model for Error.
type Error struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Code        string       `json:"code"`
	Details     *interface{} `json:"details,omitempty"`
	OperationId string       `json:"operation_id"`
	Reason      string       `json:"reason"`
}

// ErrorList defines model for ErrorList.
type ErrorList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []Error `json:"items"`
}

// FIDO device onboard configuration
type FDO struct {
	DiMfgStringTypeMacIface *string `json:"di_mfg_string_type_mac_iface,omitempty"`
	DiunPubKeyHash          *string `json:"diun_pub_key_hash,omitempty"`
	DiunPubKeyInsecure      *string `json:"diun_pub_key_insecure,omitempty"`
	DiunPubKeyRootCerts     *string `json:"diun_pub_key_root_certs,omitempty"`
	ManufacturingServerUrl  *string `json:"manufacturing_server_url,omitempty"`
}

// System FIPS mode setup
type FIPS struct {
	// Enables the system FIPS mode
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom file to create in the final artifact.
type File struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// Filesystem defines model for Filesystem.
type Filesystem struct {
	// size of the filesystem in bytes
	MinSize    uint64 `json:"min_size"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type FirewallCustomization struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
}

// Firewalld services to enable or disable
type FirewallServices struct {
	// List of services to disable
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable
	Enabled *[]string `json:"enabled,omitempty"`
}

// Bind a list of network sources to a zone to restrict traffic from
// those sources based on the settings of the zone.
type FirewallZones struct {
	// name of the zone, if left empty the sources will apply to
	// the default zone.
	Name *string `json:"name,omitempty"`

	// List of sources for the zone
	Sources *[]string `json:"sources,omitempty"`
}

// GCPUploadOptions defines model for GCPUploadOptions.
type GCPUploadOptions struct {
	// Name of an existing STANDARD Storage class Bucket.
	Bucket *string `json:"bucket,omitempty"`

	// The name to use for the imported and shared Compute Engine image.
	// The image name must be unique within the GCP project, which is used
	// for the OS image upload and import. If not specified a random
	// 'composer-api-<uuid>' string is used as the image name.
	ImageName *string `json:"image_name,omitempty"`

	// The GCP region where the OS image will be imported to and shared from.
	// The value must be a valid GCP location. See https://cloud.google.com/storage/docs/locations.
	// If not specified, the multi-region location closest to the source
	// (source Storage Bucket location) is chosen automatically.
	Region string `json:"region"`

	// List of valid Google accounts to share the imported Compute Engine image with.
	// Each string must contain a specifier of the account type. Valid formats are:
	//   - 'user:{emailid}': An email address that represents a specific
	//     Google account. For example, 'alice@example.com'.
	//   - 'serviceAccount:{emailid}': An email address that represents a
	//     service account. For example, 'my-other-app@appspot.gserviceaccount.com'.
	//   - 'group:{emailid}': An email address that represents a Google group.
	//     For example, 'admins@example.com'.
	//   - 'domain:{domain}': The G Suite domain (primary) that represents all
	//     the users of that domain. For example, 'google.com' or 'example.com'.
	// If not specified, the imported Compute Engine image is not shared with any
	// account.
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// GCPUploadStatus defines model for GCPUploadStatus.
type GCPUploadStatus struct {
	ImageName string `json:"image_name"`
	ProjectId string `json:"project_id"`
}

// Group defines model for Group.
type Group struct {
	// Group id of the group to create (optional)
	Gid *int `json:"gid,omitempty"`

	// Name of the group to create
	Name string `json:"name"`
}

// Ignition configuration
type Ignition struct {
	Embedded  *IgnitionEmbedded  `json:"embedded,omitempty"`
	Firstboot *IgnitionFirstboot `json:"firstboot,omitempty"`
}

// IgnitionEmbedded defines model for IgnitionEmbedded.
type IgnitionEmbedded struct {
	Config string `json:"config"`
}

// IgnitionFirstboot defines model for IgnitionFirstboot.
type IgnitionFirstboot struct {
	// Provisioning URL
	Url string `json:"url"`
}

// ImageRequest defines model for ImageRequest.
type ImageRequest struct {
	Architecture string       `json:"architecture"`
	ImageType    ImageTypes   `json:"image_type"`
	Ostree       *OSTree      `json:"ostree,omitempty"`
	Repositories []Repository `json:"repositories"`

	// Size of image, in bytes. When set to 0 the image size is a minimum
	// defined by the image type.
	Size *uint64 `json:"size,omitempty"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions *UploadOptions `json:"upload_options,omitempty"`

	// The type and options for multiple upload targets. Each item defines
	// a separate upload destination with its own options. Multiple
	// different targets as well as multiple targets of the same kind are
	// supported.
	UploadTargets *[]UploadTarget `json:"upload_targets,omitempty"`
}

// ImageSBOM defines model for ImageSBOM.
type ImageSBOM struct {
	// The name of the osbuild pipeline which has the packages described
	// in the SBOM installed.
	PipelineName string `json:"pipeline_name"`

	// The purpose of the pipeline. The `buildroot` pipeline was used for
	// the build environment dueing the image build. The `image` pipeline
	// represents the actual content of the image. Due to the nature of
	// some image types, there may be multiple pipelines of the same
	// purpose.
	PipelinePurpose ImageSBOMPipelinePurpose `json:"pipeline_purpose"`

	// The SBOM document in the 'sbom_type' format.
	Sbom interface{} `json:"sbom"`

	// The type of the SBOM document. Currently only SPDX is supported.
	SbomType ImageSBOMSbomType `json:"sbom_type"`
}

// The purpose of the pipeline. The `buildroot` pipeline was used for
// the build environment dueing the image build. The `image` pipeline
// represents the actual content of the image. Due to the nature of
// some image types, there may be multiple pipelines of the same
// purpose.
type ImageSBOMPipelinePurpose string

// The type of the SBOM document. Currently only SPDX is supported.
type ImageSBOMSbomType string

// ImageStatus defines model for ImageStatus.
type ImageStatus struct {
	Error          *ComposeStatusError `json:"error,omitempty"`
	Status         ImageStatusValue    `json:"status"`
	UploadStatus   *UploadStatus       `json:"upload_status,omitempty"`
	UploadStatuses *[]UploadStatus     `json:"upload_statuses,omitempty"`
}

// ImageStatusValue defines model for ImageStatusValue.
type ImageStatusValue string

// ImageTypes defines model for ImageTypes.
type ImageTypes string

// ImportKeys defines model for ImportKeys.
type ImportKeys struct {
	Files *[]string `json:"files,omitempty"`
}

// Installer defines model for Installer.
type Installer struct {
	SudoNopasswd *[]string `json:"sudo-nopasswd,omitempty"`
	Unattended   *bool     `json:"unattended,omitempty"`
}

// Kernel defines model for Kernel.
type Kernel struct {
	// Appends arguments to the bootloader kernel command line
	Append *string `json:"append,omitempty"`

	// Name of the kernel to use
	Name *string `json:"name,omitempty"`
}

// Koji defines model for Koji.
type Koji struct {
	Name    string `json:"name"`
	Release string `json:"release"`
	Server  string `json:"server"`
	TaskId  int    `json:"task_id"`
	Version string `json:"version"`
}

// KojiLogs defines model for KojiLogs.
type KojiLogs struct {
	Import interface{} `json:"import"`
	Init   interface{} `json:"init"`
}

// KojiStatus defines model for KojiStatus.
type KojiStatus struct {
	BuildId *int `json:"build_id,omitempty"`
}

// List defines model for List.
type List struct {
	Kind  string `json:"kind"`
	Page  int    `json:"page"`
	Size  int    `json:"size"`
	Total int    `json:"total"`
}

// LocalUploadOptions defines model for LocalUploadOptions.
type LocalUploadOptions struct {
	// This is used in combination with the OSBUILD_LOCALSAVE environmental
	// variable on the server to enable saving the compose locally. This
	// is for development use only, and is not available to users.
	LocalSave bool `json:"local_save"`
}

// Locale configuration
type Locale struct {
	// Sets the keyboard layout
	Keyboard *string `json:"keyboard,omitempty"`

	// List of locales to be installed, the first one becomes primary, subsequent ones are secondary
	Languages *[]string `json:"languages,omitempty"`
}

// OCIUploadOptions defines model for OCIUploadOptions.
type OCIUploadOptions map[string]interface{}

// OCIUploadStatus defines model for OCIUploadStatus.
type OCIUploadStatus struct {
	Url string `json:"url"`
}

// OSTree defines model for OSTree.
type OSTree struct {
	// A URL which, if set, is used for fetching content. Implies that `url` is set as well,
	// which will be used for metadata only.
	Contenturl *string `json:"contenturl,omitempty"`

	// Can be either a commit (example: 02604b2da6e954bd34b8b82a835e5a77d2b60ffa), or a branch-like reference (example: rhel/8/x86_64/edge)
	Parent *string `json:"parent,omitempty"`
	Ref    *string `json:"ref,omitempty"`

	// Determines whether a valid subscription manager (candlepin) identity is required to
	// access this repository. Consumer certificates will be used as client certificates when
	// fetching metadata and content.
	Rhsm *bool   `json:"rhsm,omitempty"`
	Url  *string `json:"url,omitempty"`
}

// ObjectReference defines model for ObjectReference.
type ObjectReference struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`
}

// OpenSCAP defines model for OpenSCAP.
type OpenSCAP struct {
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// OpenSCAPJSONTailoring defines model for OpenSCAPJSONTailoring.
type OpenSCAPJSONTailoring struct {
	Filepath  string `json:"filepath"`
	ProfileId string `json:"profile_id"`
}

// OpenSCAPTailoring defines model for OpenSCAPTailoring.
type OpenSCAPTailoring struct {
	Selected   *[]string `json:"selected,omitempty"`
	Unselected *[]string `json:"unselected,omitempty"`
}

// Package defines model for Package.
type Package struct {
	// Name of the package to install. File globbing is supported,
	// eg. 'openssh-*'
	Name string `json:"name"`

	// Optional version of the package to install. If left blank the
	// latest available version will be used. Wildcards are supported
	// eg. '4.11.*'
	Version *string `json:"version,omitempty"`
}

// PackageGroup defines model for PackageGroup.
type PackageGroup struct {
	// Package group name
	Name string `json:"name"`
}

// PackageMetadata defines model for PackageMetadata.
type PackageMetadata struct {
	Arch      string  `json:"arch"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Sigmd5    string  `json:"sigmd5"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// PulpOSTreeUploadOptions defines model for PulpOSTreeUploadOptions.
type PulpOSTreeUploadOptions struct {
	// Basepath for distributing the repository
	Basepath string `json:"basepath"`

	// Repository to import the ostree commit to
	Repository    *string `json:"repository,omitempty"`
	ServerAddress *string `json:"server_address,omitempty"`
}

// PulpOSTreeUploadStatus defines model for PulpOSTreeUploadStatus.
type PulpOSTreeUploadStatus struct {
	RepoUrl string `json:"repo_url"`
}

// RHSMConfig defines model for RHSMConfig.
type RHSMConfig struct {
	DnfPlugins          *SubManDNFPluginsConfig `json:"dnf_plugins,omitempty"`
	SubscriptionManager *SubManConfig           `json:"subscription_manager,omitempty"`
}

// RHSMCustomization defines model for RHSMCustomization.
type RHSMCustomization struct {
	Config *RHSMConfig `json:"config,omitempty"`
}

// RPMCustomization defines model for RPMCustomization.
type RPMCustomization struct {
	ImportKeys *ImportKeys `json:"import_keys,omitempty"`
}

// Repository configuration.
// At least one of the 'baseurl', 'mirrorlist', 'metalink' properties must
// be specified. If more of them are specified, the order of precedence is
// the same as listed above.
type Repository struct {
	Baseurl  *string `json:"baseurl,omitempty"`
	CheckGpg *bool   `json:"check_gpg,omitempty"`

	// Enables gpg verification of the repository metadata
	CheckRepoGpg *bool `json:"check_repo_gpg,omitempty"`

	// GPG key used to sign packages in this repository.
	Gpgkey     *string `json:"gpgkey,omitempty"`
	IgnoreSsl  *bool   `json:"ignore_ssl,omitempty"`
	Metalink   *string `json:"metalink,omitempty"`
	Mirrorlist *string `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool `json:"module_hotfixes,omitempty"`

	// Naming package sets for a repository assigns it to a specific part
	// (pipeline) of the build process.
	PackageSets *[]string `json:"package_sets,omitempty"`

	// Determines whether a valid subscription is required to access this repository.
	Rhsm *bool `json:"rhsm,omitempty"`
}

// SSHKey defines model for SSHKey.
type SSHKey struct {
	// Adds the key to the user's authorized_keys file
	Key string `json:"key"`

	// User to configure the ssh key for
	User string `json:"user"`
}

// Services defines model for Services.
type Services struct {
	// List of services to disable by default
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable by default
	Enabled *[]string `json:"enabled,omitempty"`

	// List of services to mask by default
	Masked *[]string `json:"masked,omitempty"`
}

// SubManConfig defines model for SubManConfig.
type SubManConfig struct {
	Rhsm      *SubManRHSMConfig      `json:"rhsm,omitempty"`
	Rhsmcertd *SubManRHSMCertdConfig `json:"rhsmcertd,omitempty"`
}

// SubManDNFPluginsConfig defines model for SubManDNFPluginsConfig.
type SubManDNFPluginsConfig struct {
	ProductId           *DNFPluginConfig `json:"product_id,omitempty"`
	SubscriptionManager *DNFPluginConfig `json:"subscription_manager,omitempty"`
}

// SubManRHSMCertdConfig defines model for SubManRHSMCertdConfig.
type SubManRHSMCertdConfig struct {
	AutoRegistration *bool `json:"auto_registration,omitempty"`
}

// SubManRHSMConfig defines model for SubManRHSMConfig.
type SubManRHSMConfig struct {
	ManageRepos *bool `json:"manage_repos,omitempty"`
}

// Subscription defines model for Subscription.
type Subscription struct {
	ActivationKey string `json:"activation_key"`
	BaseUrl       string `json:"base_url"`
	Insights      bool   `json:"insights"`
	Organization  string `json:"organization"`

	// Optional flag to use rhc to register the system, which also always enables Insights.
	Rhc       *bool  `json:"rhc,omitempty"`
	ServerUrl string `json:"server_url"`
}

// Timezone configuration
type Timezone struct {
	// List of ntp servers
	Ntpservers *[]string `json:"ntpservers,omitempty"`

	// Name of the timezone, defaults to UTC
	Timezone *string `json:"timezone,omitempty"`
}

// Options for a given upload destination.
// This should really be oneOf but AWSS3UploadOptions is a subset of
// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
// are also valid AWSS3UploadOptionas objects which violates the oneOf
// rules. Therefore, we have to use anyOf here but be aware that it isn't
// possible to mix and match more schemas together.
type UploadOptions interface{}

// UploadStatus defines model for UploadStatus.
type UploadStatus struct {
	Options interface{}       `json:"options"`
	Status  UploadStatusValue `json:"status"`
	Type    UploadTypes       `json:"type"`
}

// UploadStatusValue defines model for UploadStatusValue.
type UploadStatusValue string

// UploadTarget defines model for UploadTarget.
type UploadTarget struct {
	Type UploadTypes `json:"type"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions UploadOptions `json:"upload_options"`
}

// UploadTypes defines model for UploadTypes.
type UploadTypes string

// User defines model for User.
type User struct {
	Groups *[]string `json:"groups,omitempty"`
	Key    *string   `json:"key,omitempty"`
	Name   string    `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`
}

// Version defines model for Version.
type Version struct {
	BuildCommit *string `json:"build_commit,omitempty"`
	BuildTime   *string `json:"build_time,omitempty"`
	Version     string  `json:"version"`
}

// Page defines model for page.
type Page string

// Size defines model for size.
type Size string

// PostComposeJSONBody defines parameters for PostCompose.
type PostComposeJSONBody ComposeRequest

// PostCloneComposeJSONBody defines parameters for PostCloneCompose.
type PostCloneComposeJSONBody CloneComposeBody

// GetErrorListParams defines parameters for GetErrorList.
type GetErrorListParams struct {
	// Page index
	Page *Page `json:"page,omitempty"`

	// Number of items in each page
	Size *Size `json:"size,omitempty"`
}

// PostComposeJSONRequestBody defines body for PostCompose for application/json ContentType.
type PostComposeJSONRequestBody PostComposeJSONBody

// PostCloneComposeJSONRequestBody defines body for PostCloneCompose for application/json ContentType.
type PostCloneComposeJSONRequestBody PostCloneComposeJSONBody

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// The status of a cloned compose
	// (GET /clones/{id})
	GetCloneStatus(ctx echo.Context, id string) error
	// Create compose
	// (POST /compose)
	PostCompose(ctx echo.Context) error
	// The status of a compose
	// (GET /composes/{id})
	GetComposeStatus(ctx echo.Context, id string) error
	// Clone an existing compose
	// (POST /composes/{id}/clone)
	PostCloneCompose(ctx echo.Context, id string) error
	// Get logs for a compose.
	// (GET /composes/{id}/logs)
	GetComposeLogs(ctx echo.Context, id string) error
	// Get the manifests for a compose.
	// (GET /composes/{id}/manifests)
	GetComposeManifests(ctx echo.Context, id string) error
	// Get the metadata for a compose.
	// (GET /composes/{id}/metadata)
	GetComposeMetadata(ctx echo.Context, id string) error
	// Get the SBOMs for a compose.
	// (GET /composes/{id}/sboms)
	GetComposeSBOMs(ctx echo.Context, id string) error
	// Get a list of all possible errors
	// (GET /errors)
	GetErrorList(ctx echo.Context, params GetErrorListParams) error
	// Get error description
	// (GET /errors/{id})
	GetError(ctx echo.Context, id string) error
	// Get the openapi spec in json format
	// (GET /openapi)
	GetOpenapi(ctx echo.Context) error
	// get the service version
	// (GET /version)
	GetVersion(ctx echo.Context) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetCloneStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetCloneStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetCloneStatus(ctx, id)
	return err
}

// PostCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCompose(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCompose(ctx)
	return err
}

// GetComposeStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeStatus(ctx, id)
	return err
}

// PostCloneCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCloneCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCloneCompose(ctx, id)
	return err
}

// GetComposeLogs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeLogs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeLogs(ctx, id)
	return err
}

// GetComposeManifests converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeManifests(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeManifests(ctx, id)
	return err
}

// GetComposeMetadata converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeMetadata(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeMetadata(ctx, id)
	return err
}

// GetComposeSBOMs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeSBOMs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeSBOMs(ctx, id)
	return err
}

// GetErrorList converts echo context to params.
func (w *ServerInterfaceWrapper) GetErrorList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Parameter object where we will unmarshal all parameters from the context
	var params GetErrorListParams
	// ------------- Optional query parameter "page" -------------

	err = runtime.BindQueryParameter("form", true, false, "page", ctx.QueryParams(), &params.Page)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter page: %s", err))
	}

	// ------------- Optional query parameter "size" -------------

	err = runtime.BindQueryParameter("form", true, false, "size", ctx.QueryParams(), &params.Size)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter size: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetErrorList(ctx, params)
	return err
}

// GetError converts echo context to params.
func (w *ServerInterfaceWrapper) GetError(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetError(ctx, id)
	return err
}

// GetOpenapi converts echo context to params.
func (w *ServerInterfaceWrapper) GetOpenapi(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetOpenapi(ctx)
	return err
}

// GetVersion converts echo context to params.
func (w *ServerInterfaceWrapper) GetVersion(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetVersion(ctx)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/clones/:id", wrapper.GetCloneStatus)
	router.POST(baseURL+"/compose", wrapper.PostCompose)
	router.GET(baseURL+"/composes/:id", wrapper.GetComposeStatus)
	router.POST(baseURL+"/composes/:id/clone", wrapper.PostCloneCompose)
	router.GET(baseURL+"/composes/:id/logs", wrapper.GetComposeLogs)
	router.GET(baseURL+"/composes/:id/manifests", wrapper.GetComposeManifests)
	router.GET(baseURL+"/composes/:id/metadata", wrapper.GetComposeMetadata)
	router.GET(baseURL+"/composes/:id/sboms", wrapper.GetComposeSBOMs)
	router.GET(baseURL+"/errors", wrapper.GetErrorList)
	router.GET(baseURL+"/errors/:id", wrapper.GetError)
	router.GET(baseURL+"/openapi", wrapper.GetOpenapi)
	router.GET(baseURL+"/version", wrapper.GetVersion)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x9eXPjOK74V2H5TVVmfu37SJxUTe1znMu5EztJJ+uuLC3RMmOJVEjKjjOvv/uveEiW",
	"bPnqZHZ3dnv/2OlYPEAQAAEQAP/IWNTzKUFE8MzeHxkfMughgZj5y0HyvzbiFsO+wJRk9jLX0EEAExu9",
	"ZbIZ9AY930WJ5iPoBiizlyllvn/PZrDs8xogNslkMwR68otqmc1wa4A8KLuIiS9/54Jh4qhuHL+nzH0Z",
	"eD3EAO0DLJDHASYAQWsAzIBxaMIBImiKxYXwqLbL4PkeflRDNx7ah81y06UENSX6uJoI2jaWYEL3mlEf",
	"MYElIH3ocpTN+LGf/sgw5Kj1zE2UzfABZOh5jMXgGVoWDczGmJVl9v6eKZUr1dr2Tn23WCpnvmUzChOp",
	"Y5kfIGNwotbO0GuAGbLlMAaGb1Ez2ntBlpD99PrufJdC+0qhnv/wAiPAMyjIjREXuVIm+89cdjbDCfT5",
	"gIpnvdtxmLxJLvw6D1U6wtJhXYXGtoAi0FySQBT0cBIi6OFc0apXiju7lZ2dWm23Zld7aRjbEMUzi5Hz",
	"ZlfQQLvyERLwg56LLc3CfRi4ImqXZOlWH3AkgKBAfQa/igECpgtQzPtbFkDgUuJkAe31A25BgWxwd3ve",
	"JZgDhkTACLLzoCU4QG8+ZlAODTzsDAToIcApJYgBMYAE9CkDVAwQA4FaW5cIyBwkeL5LumQKi2ABktPy",
	"AWUCMTkbiE0GILG7BCcnxBxI2Dn0EIBcTSX/jk8HprNNt6hHqYsg+fimrredi0gxYG66KI5PIRuljv8e",
	"MPQRcsEedFDEoTNSX2KU9hU2NR6RDVQHuenAC7ja54Dg10AeTaqhg0eIAIY4DZiFgMNo4OfVFstJ5GZR",
	"DwtJSX1GPdVFLhRxIfedQWJTD1CCQA9yZANKAAR3d60DgHmXOIggJslQb2RCoCjA0jjWpRYUZnuTCzw3",
	"X8JF+oyOsFxkCP6zAj8LxgPEkGqiZpHkGbi2WnyIF0hkNwdzgZiC74SOJUW7mAsAXReEYPC9LhkI4fO9",
	"QsGmFs972GKU077IW9QrIJILeMFycQHKvS0YUfe3EUbj39VPOcvFORcKxMX/wPdQFj7LiZ6jSbYUyiXE",
	"4U8S9YQKwH1k4T5GdhZgIX+0kR1YiQ1ZgIdZpEv2QIEkp3RBGe+7nLqS5LIGumdB6dDAguTWDHOsZkw7",
	"7oJeBMIztueBah1IkOLNfgCYKqrZ9V7ZysFeuZqrVkuV3G7RquW2S+VKcRvVi7uonAadQAQSsQQuCYRu",
	"tB5UhgT7mNhqrzWHKpkBrikT0F2HFkM6FHiEcjZmyBKUTQr9gNjQQ0RAl899zQ3oOCdoTk6d0yDPIKlm",
	"7aB+rbedK1mVfq5qw2IObpfLuWKvuF0sV3btHXtnpeSdYmx+b+cocIX8XCSfkxJyHZEzA2RsgDQQ9t0A",
	"+QwTsaHktigREBNjMyTJpRl+09TBJRUgryfFN5Gn7ABJooAugEz0oSWVsEiv+4WhfmYv8z+FqYlSMEp4",
	"IRo3Td+zAi6oh99hdA4tGypadjPZ7fuMopKiaNqYC0bnV92RGoz8hnuBYl1BQcBRpBFY2mjIg1YfuKgv",
	"APJ8MVGfBpSLLtEDgzF2XcVJfJ63+8imDOYqu2kMrOiMp5lu1lAyqf4uwerJ85IL6LrIXhf5ZhQt3FLw",
	"71E7MEZYcvoGAdDFRjXy9Sg8K5UquZe2+rkHreEYMpsrLEEBe9jFYqJWvwl0aYCFvDOHrxCWhRj7KK7S",
	"oBkhxlO1gQbgyBshBkwLQJTVm9j+nfxOfqe4kuVXM3tzjlk2YP1QzOI01B1MP0rsWQxBEWlnEdfjTdg+",
	"HHKShs++TVf1Pzq4Ui1xKnkeyZ8/C9QIwXLUVHDlbBMukJeiD0pdjfbBtA3wpG7lU0xEDMQfAsZMmgpS",
	"mtA4JLDnInDUum4Dj9oo1XDpY4bG0HU3gMR0CMXVYixMpdVmq14ooKSQTbc0mpT0sRMwxCNprBqmyFjs",
	"EByeDMugaIXtlO9JiQ/Fa882GmFrhbUT7wB0hyywAsYQEe4EUOJO5OnQD9zocEG2g3Ice76rlOtcKLIY",
	"kEuYOUUKNhoVuA1TFxh2XLnCqOH3bGaIGEEryeBMtzJGkYtWtT/Xrb5nM9RHhFvQX5vQrnxE2s3GtZbz",
	"TKjNwMR5VrQcd09kYCBozh15mVkfRRu5yBJgINVYfbYPjbobHtHRyMjOg61woC39XZ79DI5BQFzEeZcI",
	"pTNDhpR9SRnwKEMJDsdS3cfWAFiQI6kyR+Oc31/kwZYaG7pjOOFdEnDE5e9ZgKTJOx4gJbjMFIQC9CYY",
	"jI+fB1sMjreA6ikhi8DnXZI2yAI4jVJCAk+5H+A4k81o/EWo/JZqkfmU40Xnxm3sq2T6McMCyX8UkLAK",
	"k8DLq/55u5CU0MYhcEkFkiiGQn7jIRKE0qIAFKAXYNcGAnsov75WEZFTBF3qGcQG3Fs11O1J+yJx6qqO",
	"/up+1/PdOGJSJqwEvx22k334YIgmi8Ut5wMwRBO+Lmra7ZMzlIoNieN3SlZydyds9z2bCbgWOOmwya8f",
	"Of/ueJrJ8H2ZgqTO7xQdTVsZ6ohepTNoOptRnaCA6faShDyU/2p0yIHvQjkyehML1f35wdT5NzsSBA62",
	"JS9D4+Mw59v0TGBUOcMpQVf9zN7f59Xl6BdMBHIkQr9prT/tsggxD3OpxXKgB4gOKgURJoBaAqrjy4Mi",
	"AUhxu1pNW64PxSBNUxcDENmUbnJNSnR4E/P73IjpRHc1JvquKYm/IMSf7PVJ6JtR29UKv62iyqn2mCQt",
	"D5P02zP5a3w9RrXEBPQmAvH4Msql6k61Xtmu1rOZt5xDcwaUABOxXdVWXngMJN0RhRFkK+2SWOdsBO+K",
	"BU8VzKUWyqxOr7vZwDKqnZadc7cVlAm+WO6oz+BXabZSJgCDxEH8N+Vr9RkV1KKuEktSO4mj8e+ZcnlP",
	"WH4mm6kXzT+wB331z80usdaU9OGC4xJfylbtQlpHWIYjPKlemwnLSNmaI0op77hgCHqpy33hlDwLiF2q",
	"flkBYjjNafvqshN1kqKButiapHourwMhuTfyOgPdFrQOQqEtD2Yg5TXPAi4FCRQAkolWwoklVaXIrw4E",
	"7RJJt85A8EgLlFqPBwW2oOtOJMURpBzaRizJlbhYDhVObma2KOHUNfqIkYR7mSBQ3sN5+ceo5F6zynnK",
	"2RSLMQzOyqHpTEuZM6YUzW18D3IUMDdJf1NxEXp9LZvkGbIHUHt8LX0QFmzMRYENkFsv1Atv9e3n7WpB",
	"jkh5gfJCAlsMp/qyZ/gIKWs2jrmEFeuihU4ix3esAbKG6V0d31FKU3yVK4FZsIMeEtDFZJiOKQ8zRhnP",
	"aw+gz6jcjjxlTiHs9zepIP8eegjL3aBYLG9DZg1+1xhcA216EhdzMQ9EBIP8nLcQEZSr+f/GkIsgR7/X",
	"c5rVYzND+f/bVf2Lgm8fcnTVXgcW5U98HlDRx2/pniYuN5UD1RIyLCbyfBMopm+oy9uQShddvy52EDJM",
	"5bCxj9Hpre2Z5+Xkwbk7Qgz3J2mfZ/30K7jtzmgrmzjqVniynTSJqfVHbIfuaykHEbRDDSK0m7MpGFnk",
	"gG7oa0jaB1PgY/4daNv6kldqVoLG1fspCarmpXV4fUDTfDwdM8EWB7IBiO6K0oZMtZSkhaTDG6ShlND+",
	"OB/kkF2u1Uq7oNFoNJqVy3fYLLlPB63SZeewJn9rXbLjs0N28Yi/XFzcjYMTeNs49W7Paev9tl9+PSjb",
	"B7X34n7nrbD9lgbT/BWQXE4pXVXmfExZ2kWeuWk2DQAXkKmTTAzAL9u/ZMEvtV+yUs/9pdz7JfJA9BDg",
	"gsrzD/IugQQgYrGJL8+4cKQ8uBIDxMY45rjoISCUfWRrFXpqznRJ1C/Ok/HAIKSVvtkbcwcToD4a8kzV",
	"69PIWrLPj1D1uq71eFzYPrUV/UytgWUHckpcmTKt4r/cIu5TYiLOXHeNUa8UZLeojxgiFlIWyMzNop0k",
	"p1K5gqq17Z0cqu/2cqWyXcnBam07Vy1vb9dq1WqxWCyuVlTWkWrR6qaXnj++qGXtE1erelqNz5b9H4RJ",
	"vaRz6vBPXZS6N1Zus1T9xoCQNBQl27A+tNAf39NE85C+4JVOYvqC1VrSL7INQEtRcQEJ7iMuPhUfXnzQ",
	"jyNj1jSORl++MiRg6EP6rIVRqbWhZ4t6HhapsR+/DiAf/BbKSrkDApjm2R+4VtXaACaWG9hSVbs8vL9t",
	"bHi1GiFiDUs1hr9bHeu1Uo8iVOiA1ukOzcQXZDO9KHLi2/dZzasXj6pYy0e5eQhDSuRCLPogKZGkLZWr",
	"p973KK5iU7wsvfORjUMcznZe39cwO8yPiok5LkogILbt7f2ri88VjuEy55VMORewqRV4yqUr7RAVrK5v",
	"jjTzRA4AHRESp/21BpxGOprrj8PpDAEPlB9ioHQ1AaRtJoAYUzUQz6pbnXAQfSuCyAgzSuT4yrkVa9El",
	"0BIBdIExzaMrSjXvukyrNlxOn3pfsEwu6uGXysTPUCLSjj4ejbt6aUbDyCa6og05YjpKGkOsCY/ki+lA",
	"6/VJIPJeZU7M7oMZKLnAdfblkDHKUhyDSECs3EOzDpGEhQ15quk6rxpFjecA0OuR0tBcWPLAshCXa+lD",
	"7AZM2hA+IvIokguKWXVRwzmpOY1Em1vZkmDmuYCwMEwuCn1dGEWsQwnTrk0NGU+9jeGgYdBd8p5C+TLZ",
	"JG9+Um43NeuegE6qee3y56kTY/7iilEXdM7bQLXBfWyFrvZoUhVVv8r9YRaYalqFS/pIpPmSbYn2wxir",
	"VjJ8cSZ4gnIlNFNRBZ0UEQ6dDWfQwdWpBsEq3MRk4SbxXI45+2cdbPL3UOKHGupcSP50MZSYcGpNY+mm",
	"vUk4mLmwuTm4TI/1n8HNawAneUwL3sQEnhfMfuwtwdpsKkM2XHIqtSm1ag3f9r+Ja1u5H58d30l3QerP",
	"oa8yvc2HvOPGV/bT/f2nu78/zXPNufv8Ub/0hyJIk8HjnxX7/bw8wuhQxUPF2yQikmN3hJiApCmWB50B",
	"4qhLEr3jgdrytLWRz6k7QiYZRzCMRigaPw8aEYLcSVbFg/Hp56mnFY5MPg/2fMpiF4n/mAuF+sfUjd0l",
	"RvpOpeZ6eJ0VdynonQn4/ZcE7a55ib1O1O3aQ62OmV06Quu6vUmQbHgDPxfuteha5d8qUjaemfIzgPYv",
	"G0CbjJudOvJisS0+5cJhiG8WyfIzCPffIgjXhxOpXf9LjkrFdmufl10SsuZVG2DBkdtXWeITPRihKvsX",
	"jiB2VaZC0qXFKBWAsi6BZGJysSWi4z5sFcQlDfzfFMzhxM8cCQ76GLl2OObccjAH2CGUhQlaa4nb/4AY",
	"4liO48p+8bYfiApe//BfP8r34PLo2g0cTPRxNm/hLTGIUseLdJ3FEcORovYjYcOI8IChZx+ysGTL8uoK",
	"h6o9CMPhge4IYnocQG84bi3HY5rWiCuerkYHF0cxxSbGGNv/kuDiKVhLI4x3arUfizCOB43MhRnbmP1g",
	"lPEMNqMIYxNw/BnIXDfUOHLXfpYv3TJ7OJ9GG/cAyx4wlhafkjyynivY0qlqpvnMwOnuarXkc2P0r7ds",
	"1XrJrdBa8kqj+iMXINJG2jAwunVwZRRiQEmPQrYqRNrGz17fedbofpZAPHvQepaiasG+4oA8+0HveYgm",
	"zwPIB6tbYcKRFbA1xpO0/2whE7U97zSBJJAyNFDAyiMOseeFFU7miF9ZbJshtK2D6aM0ScCRUMUfFh4o",
	"qyS3jmlUJWVmxs5k1zqN/gKpK3/iebbi1uFn2sx/T9rMimyZ579auszzwnyZdNfRz5yZDXNmvi9BbTs2",
	"6g9hNQRL3cvq5HrKgK2D2FOOXR47MVITNmPjTUeJ4VMglyCxGe4S59SqWXXj5KR9ITeOCH/DGoUL8f4U",
	"ZjFtgPR9TGwAo6BzgsSYsiHQV8w65BxIG1P+iyEJlSWAYLDfx5a6i+8SMaAcRT2iYmDqWEZCYOJER54c",
	"Ke3ATPegkpibUvbMAjxXDiacVjk6oO+7E5V4FC+RN510QajAEhYNhw/PFmVuLwxB6gbFYsXSfdS/0d8L",
	"+jcP8qH+5dv/6V8uGk39w/9hnyOxp39V/9a/r77QTKOF4+b1R67+e4E1RGKxxxgSrT3I87bdaVweNG4P",
	"QFtQBh0ELBdyDvbVEPnZom/mj5yZYWF4XTopdAZIm3kzcSHRvY8UmqrspA2a1PMDgcAhcTAJw6+6pBNV",
	"4FIDzdTEG2MxMPrdcfMamFvTrPFvYq48cUk/mw4h01ULp3dQqmZRonpbVCyvS7ZMGBvLQR/n9JYHAbb1",
	"jm+FmoyZTqoFIgH1JsX0ppUS51Epl6i/x8qTRWsKvcXxS7UYfiXXG3yq6pMRKqH8G9tq9LCWXR60EQLR",
	"Rb9LAzvvUOqYcBquSUeVNCtEJfFMFcJkCTwVWBG4AucM5FG5PMulHHERKmmG/8ivplJdSJ6aMKNuv0k0",
	"W1J2kWRa4iySUbBBPdZ0MWLwotYNwuYSXjVKkpLTyFeRZ75LVOyiIRKFdXM7HEvbjBRLM426k8mDewWB",
	"VoY5gAztdQkAObAllc29P5AHsYvt71t7oEGA+gtA22aIc21KMOQzxJX5Es1lySHAzLLy4IgyYLCXBVvQ",
	"xRb631gI1VbezGzOx4butyEMemozxKK5vUlO+bNz0Pf/F/o+96nIO6ZT2CcOkrJcNsWGWX9YeFHCNYMC",
	"28OEp+LAph7EZO8P/V85oWJP0A6wQED/Cn71GfYgm/w2P7nr6gnDnDBz0kJh+s5iZMp6W1Kl2pqBKZ3r",
	"lpNmWKxSCweVHgXJpEtC/HZndFdFcHNUkYmU0ZAe1t28jLFT9+bRnMlmDILjP/4pFaGjc/fzihOqs1mO",
	"/zybNAO5hYgNicj1GMR2rlKs1EqVlUZSbLjsqlqHx6Hpv4HysDxH0ogl7RyYOlV+pb4e/rfUPMnV9W5n",
	"Bvzxim+t2HX7Bhp02G2FLajiS21tL6xzmX8YttdhEVz0KBXrdj6KOqQqiXNzbBySZK6CVjmYVbtluD6K",
	"r2wDEFIjI68ZHWGu783B3e35WgGOqdDFky42Awwya4AFsoTx0U6ZNgqtW6D46p/XiH3vTHx9x6izkVaG",
	"KbQ7slVKValPuIqd+oWMT7I45/U1PiK1yGzkG8qDhwEiYTHxYrw+ruyA5cHqYYK9wOsSG/VV+cveJNZO",
	"6TXJw6Va3q3ubu+Ud7cXOZm0uv5M/bXShpKW1LS7qVGerlvLOXVqiO6nbBWluPoumq1ybrJRBPKAXiTv",
	"Egg48iGTwtG0tpG0uLSyqw5YLDigYxJOkQcXZvwusXFf3TCJcA5pRYyRtI75FIzwm5GhqiL7ULkCGOoS",
	"Hvj6xN/gyl7jqqPGXXmQJrgkwQAzVPot5EaVETN3qPrYRy4mK61Gs0wT/wzCbsa6Gxg7K4rZ0KP0pMFn",
	"bEKVWBTVNs2nHtYhLH7Awhcv5sExH6M65qaTDqv4hwKPUSr+EYMRGmuwT5l2bMxnItkBkjJvyhyqiRlU",
	"/TIdUMVnhAqkNhQWZy2BgyBKlyBQbheg/S7h1IuzIc+aIBwPqqiViMzCOROE1iUGCflYVE608pAcUkNy",
	"eI96a2R+hTc1W7K9oqstY/rEdm6dPNSo/xJWNytLAJAHzWQEXfv64KsUalPOiq2d+/ZbynJnsz56WkuO",
	"QMrOkH8KCU7ZZ4FWisI77LVznqKr2I1zvky2VCRF1xsgmZc+03mDc2x2nKXyKczZSqJvo/SorCZp/U8N",
	"tP53WCLJ5FDN0XjsjI9NBcdyGjjmuQHMsUGAzV+xf3LoR3++a2D0KwQI+juJL8k/Yv1UZGeUrmz+CoPJ",
	"zQ/ToM1sxlF3D44VDeBIlSkyaNR/Ex0wFTmp7sGemxxafogm1n8kP86OwuB4Og8VqfGomWzGxaMkBEqp",
	"gG5OhwFSS0I94r4UX9N/5egIZrKZMXcXbJFk4jNTzSjJUfNR2D/gxW3FA2OT4/PApjlCVVEQe7NskoBA",
	"IRCx14/WOotCbTdRgX3JAynX6up3DiBzTH6uOVgkQag8JgZ0bK/KmJcqlBRmCV8codwTv/cps9Cywi+L",
	"rUUzQVQRZTq0/pKzUS9w1ksoOzO51z+QWjed9khn4TRdGti5fcgX+HJV3kyyZ7lYLhZ3izv5Yqp/UkV0",
	"pGcIDekLTkkPkj8Pgt46iVWQD2e9EtVymv0eq+E+haOy+qUeA/50KrO50xGnWPm2YG/CMh+zjhjJvCab",
	"lqgyDnOBRESLId1y0fCLzlQl99fBThpNhcFVySGlar6gLr+DFiQuGcts/ougArppn2awoCbNRk/R6Rfg",
	"dOfswlirrHqqx/3IHZSK13/mcIRWR7t0BphH1yWYSMHRS1hK+mJj/651fvB8ftVsnLcb94dx3Rm6XTKC",
	"DOtb5vDaUhJf7PaZw1GoX5sbHHWN4LoTqWNjrt7ZknaejUbIpb5SQgOp5hN3ktW3Q9pNOg3C1iKILXjp",
	"amYvYjhZiHO0oeNKd1rhthqiiQp9m5eqbWTsh7AJcOGEBslQmyA1JdyFxAnS656ENyY6aWPuVYmsiTVh",
	"shVBoIcs6iEOjIc8qx4EQq+BMmSk3QGZ3E6LEhuaLNuYKxqR57t2/q5zlKt/9A7+qtnajOYXj/CnPD9m",
	"vEB7f6SkFyIiUv1pDfWom7KR1dU7RyIbMZuk9j4S1kAyhhklD1pSCUPmluQfAXP/oaweJEIvRLZLtNGd",
	"yAhULhJTpkbxzIL7eh3MlhJaB4kcC2GVvQBNxR3wq9nrPVAsbxervbINt9FurdqzK9VevVcvw3qlhmpw",
	"Z8cu97aL/T78LatDsHoMEmuQc/EQARbVDZiOxwbInSYlS734t5lbw/kW6Qd7f776zBrdTAbEcuF4gARi",
	"njK/xwNkUKOvIhPvZnmQQAcx8KsFie0iH5PfALYREVhM9Jt+mr5UZAVUJs9cvUjQpIQHHmLAksSlahvM",
	"5n1CDiwXS9ZMthkg0iURLUV0IKVmSFgLylGuH686G309xwgDsxXz3tn0k3fBkZxWbsMcpGqGVN5cWBP4",
	"Z9Hfv2DR3/RtSDUUw4jTzRazGJzsdNRlkC2BiqscQrSxZfkj/dL4NHwO6tMqloSOVlNPTdBQmciDI+wi",
	"4Li01zNBN5F3LtslyMmDLZUKyge5/7c1I92FF6RWHl34ZNWVueWMnqxaAlf46FnPhWSoK0vpih0x7TEc",
	"JvECGnjArm2pt8GU3hMux6ymmi+V8nNLqeQr8McvTRNPnX3GpiVeYJuPgoYEKmUuJyh1+YfhjhcJnL/I",
	"S6Vh5NMFXxaWmIiZ7/N2OnY8u7bok/a5L+GlP5bS4Io3GbUXeaFdndVIiGD8JvEWuL7WJT8UZgg5So+2",
	"3zdftDUV1agzxtdU4cgsezVnsuTNHJVUqC17cyckGEKhxqhKKi/wpTybECAlvJc6SGbwHK02lRBnELpI",
	"+1dladYyAaKWadOpvNgFqZw26T/7KtmTr5GyegFJlBzKzZCzD7cazXK90cIxvi8CezZif1FUwsq84GUT",
	"Xa+aR9POc1jLfvnlR+QnTp9sPYJNWOj5LmmElQpVvrs+R7ZMpaWtLNiaFt9Rf5miP1tgug4VPNglPTRV",
	"/NSxozLn9YiePkKSkWCU2TrA0GfIQrYyirAuFRC96i3nlcp+j45SY71jJaH+eZWgNq78tF7qmeM7pphb",
	"8nnqqSSKzJkFFsy0KtRM2NT1MRiiSVQAQJ4F0wtqpSAnDbDEKZmT/9s/PG5dguvja3B9t3/eaoKzw0ew",
	"f37VPFOfu6RLvJvW5f5xw2pbdP+wcXDerz+eDNH76Ta03YvH8Q48Pm65p9AV9dOX8lthv3z2ZdDqt4K3",
	"Y+Hfv+ygLjm/dQ7udrZfYKfm3x/UvKOL04o/RATdFqyO9/p6M7yc3PDB1zK9+To+fL9r90rNy4tmv3ns",
	"DL/Wb8pd8v40ZC2ryY6KN+UxO+u5MLAHd1/wPSSNA+6V6o+Hr7xXa9xVdmxxxy4qN4/2g7N7++Urvu7f",
	"12+75Gz/pVOsjO73r+yLNn+s7J7DJtlu+aWrkV9vHdJCCx3eP5ZevebVdQOeFXunJ5Wg71SbARryL512",
	"l4xvHjqoef4WPJ1vX118pVfXZ+PRxU3/reeUvh7UR8FT8Uy8FKzLk/IbDIpvHm8EuyenPhqOrq5v39wu",
	"mbyKl8lTn9F7jI4m/vjJGd2MBSEX9YLTPgwKp/cd9lislb3Du85O0+rtVIfWyVHnqH8xdMnwuNAlxf5d",
	"tXELa8XqSeXtpTgUPVQZnVnXX+n1VXC2f89P2qNi8e74sTG5RsHkS33Huis8Hg4udoaV9v3ZS5dso9aT",
	"M8EXV8WxW3o8Prg9swJ3POS7jS+BO3RKtNOr8sq79zS6Lu4c087bQ7X8As9qD+0vl4MnhLqkvl38Su8H",
	"Pat05re/vPSf6Atnh+Kpft27e/ryODqq3/rMfmiwl5Pe6bB86t+eNd46gzd+0+D7g+NSlxTPg7fyA7zY",
	"LzrlVu3aurBPC9brCy3WLYu97H8N8NsDwzUc7F589euvnUK//X7pcbvlkHrh9emsS3D9JnD7wc5O8Dp4",
	"KIxFuScIFs4tf30ZvF0EL4931adedTAUR/XB2V3h69edavl1cF47GzduGzeN/S4RB0fHTw+3I8s7dM4O",
	"Lkpn7Ub9ybsf9iqng/PORen86/4EPpQGFnEb4e/WyekIevcvdrM26hLLs77gm9Or/f2L/WajUT3Ch4fo",
	"ZNtjg6OTneCe35xfXJSLjzXraUDeHutHDU/xUPN4XD9qjoetLtkft46Pbuhps8Gb+/uPzcb4sHniHDaP",
	"qo1G0xneTHt/uXxsFHb2H33HnbQbT48ng5fJ2aBLCl/62+/X/ftR76RcPHytDFs7V0f7l0Vy/vXL/l3J",
	"C0btL6+doF15OGf7Fa9yHLjCP7s9PD07F17t8KBLSuz4/WuDdkoTf/exVT9vHNgXzebV5KXxwunDXX3n",
	"8S5ofin0yAvroNvy+e1Vsz+5bu5sP+zWa/jqvku8WvtLj98cjHea5XPm2o2L6sVBQCdPpTYWx/CpenZz",
	"fi++dA5hqYr5Y/u4+fJOd64f6/eV06thrdglzuuDUy9fFnpe+fC9vdOpVx4OD3old/RSbbmjN6f1eoac",
	"Uun96+Obxx7bT6enzf7ovf/FvWxvB2/OSZe8vBVOixP3qXyOe8ds+7jRmFzt3j2wxlN73L4oHlovnfr4",
	"sEnehu2DYPLqPYzvR5f7X4PD1n39ClUeu+QC35X6p5d1bu8c+PzorXbx5atNLshN+8sJe+lcnx1UvAfm",
	"Nmxy2BnYj/f1l6eh/zA4mPBKYXcXXXXJYFhk52RSfLkcD2HQL+C7+pW1/XV0MXw5v704dWp3u/dnk9Pg",
	"4UG8j7+Sl4vL2sPt0f7rWZU/Ue/iokv6otc5KX2pTXq3D4VGZbTfg2+3D2Wxc/d++WK9o2H76RDD88vd",
	"88KJddps3ZZujurb9fKB3XAPj3btLhmWnRv82L5pQHhaPD1tvJ+Mboe3p+fnzln58eYRn1zeT8qicjo5",
	"6nMGvdq43Xy46g+uUWtyvt95Ou2SEfMv3ese6vPObm2n0y/vX7YC5/2JNWv3bwfts+GTczso3R+P2q0b",
	"0py8D28m24d35ddrHz/UdqWMGly3vj6xM2qdVc7O27sF/H5607l1xctF4/cu+f2639npEnW6HF4eLDt6",
	"FpS7ogw9c+6mH9I/qx6ufvRnqTv4sx4Bilf/SfW6yPFCx4YuEaSc6jGtCHKp0HCgTK5YRomqPNQlv4aR",
	"TL+lViGayykIy8zSDSttfa4fPekqBws85WuWJjCPhm5mV6eqkg3bji7qQp+red4HBmJAGX5HtrJn5vPb",
	"13qtp9F+wGJ4dVK9q+9UD22+f0cmolfpjUe3jnPi3ri9x6/uDikVR7sL6tympsnf6TeOIvNH50mZx1cl",
	"SSUdQ7aHyeqIb66CCiSe0qzjtTOXPyEDGfQmsbd0UqrjhsUQ7XRJRFq6S+lTUpNXQkP6KmiLbwyMB/lw",
	"XVhk25WQ6GTtTbGSymNxv8O8x2WNMmN6hLhTQQsVCzFhb9BZNl/mlljgb5kPiGbUDqKMoaVFR2cKe/2g",
	"62ZumMXQzy503uUaCPpsKmLDmZfYlsvK2V3YS3mRRj+/4VO+waiJEm4zwFoCj3S5JCN1EzldHFkMiZx+",
	"/Sw6yqPXxlJotwc5ek51jMz7RdZQD8JbuMRwiwq9UOZAEvN4xYPMqsVKuZp+CW2tPjuje4++C50we5sN",
	"LF1PQN8bxir4hAnX0OXUVI40AoqDllnRzOm/aE3Jkkbxpwqm25qXvBpD7Eq8zhwnCbxlZ2kiAUNsg2Ob",
	"k3YIdWLl/zYI5wm7rQjoIcLXUC0JviHCB2GjhJ5VzBPKxCAHPcSwBfM+pW6eCF/quZlsprTs80aKWbwE",
	"4uJLvbBVNjww1CFy12kmNIO7duEQSjoj64V1zl9skMnab9PNpgyt7NOubNZlrsDDyjneA4Y267LgFYlV",
	"3VIi/1Z1mQubWtVh0f3T92/pkie0PfQTQPP5VKqQAeaAD2jg2oAhFaPQU7Vkr/qgFwgwv0k6PU2FmgmV",
	"D5Oy9zowEHgIEhMOBV0XpDQEmvJ4l0CGtODTtsXcvDBqa6TkCFN1Max98xLgLmGBi3RlWYb6lKEsGCMw",
	"gKOodIaiZqDSdeTqegjAMQwrhmEBMCdbokt8yjk2cYoeflPROB4U1kBfEpj9AII6yiKSQjninUV3WLG0",
	"u03ee5xJ3VibpdbsMZu6vQFDrdkj/eWRtXljzfYLbhJVEbXNc22ibJ118lJN8p9OTF30HJK5bg6J4NsM",
	"uWyYXcMCQhal0CRyEeeocOMFfTBtNP3WfWbIbwsPosWpQHleiXJwwoyfeNoMtXDeCAxdAkUiMHD9vEkc",
	"NqXR01G4+RPK09r7H3qTeE6b/vli8MdeDF7D+lg3auZ+GlqSlvMwfRdz3rpRDaTC9rGYlbChKm2oSqFi",
	"MWlLxtOA7CPINOX21L+OwsWfPnSkQq5aSkNBt4vWKO2szPfvynDq07Rod11pRlDjilQx/TpiS2fC8rxK",
	"N7OQeXtYk1Sm4UNrgEBZZekoYyRyWY/H4zxUn5Wf2PTlhfNW8/CyfZgr54v5gfBcrRALRZZX7X01vcnJ",
	"ZECVVALQx7EQnr1MOXzIQH7Yy1TyxXwpoytcKjQVLJcSxAt/YPu74t20ol/HSIfIaAmuyn8BI3YlFau4",
	"TSTC16f0y2wweqnRKFb67dKY65QylQgxzVVWdTswJUAJfGTr5NioGnHL1qDEX0FWkeDQQ0KZMX9PeYc1",
	"rDgQAi8ocFTZMUwUJ4hBGPm0F76JFxKZNii1MP9THiv+JmfTj1SrzSgXi7FQfJNC55qQgsKLKeY8BWip",
	"qhHDkiLnJGbiOJEkUv3EqU1m8PykLaIV2jB1Btt66tKfP3UjUMVbh0h557EGRM9e+fNnvyNTB7ukQB8x",
	"SRsgom0NSfWfAcmQ0DGZ2YLaP2P37wh683XAt8o2B9RSz8vYmbgIV1wcCu+/f5M8wgPPg2xicu3jQkgJ",
	"r4ie1DiF8A9VdjXtib6mrjcEAUHjsGsW+FQuHYeR6dzUNlR+6RFiMBTuSt4b81G9UasvUjCLG5N8XnBd",
	"Uy7Cp+q1kEFchI/efw7HJ59r/p48MaUw+z4nb0qfPXvLTtt681EV2FDKELL/ZUKHTd9Q/il5fkqeNSWP",
	"ERppkuazlKcN9KUQhysUpcRbz2upStHA/2XKUgJTKRSUxMtPhemn2PqLKkwL5Zc2BONaU4r+IptMlZg1",
	"5ElMWP0bSZE/QfeKYUYN/M/WvmLz35pJ0khKFUJD42nF1p6qF2be2E6XawK9iYLyKiXhmUXt2tKr+lkT",
	"pPHm98SpLdGSqFW+hAFcUyXkR07xPiaYD2KHOFh6hmMxPbp1VQh13eMhAQEmmoYxJQD2aCBMIgEPXLHs",
	"mFdFTn4e8isPeYWnBawhSSAqKa9vCiMDERNAqH550gpcyEwhOfCrGNDAGZi7utP21eVv+f84RjpW9dKd",
	"8BI1pPI0NgrfvF/NS1HLNdjpFomAEa4ynaJX9SUwygY34ix8Sl/Jd1NSM2psUcVYUbEps31hSVEoQNwd",
	"aypE6rhhSMIX83PhcPnaEla8iFDwkx9X8uMUWQuYMrHdc4z5n8lrSfZYg+li6cvLeS4qriJZbo7P9GsO",
	"6A1aInEQMcV+yAY20rXbaILXIte/qsW7jDNCOH8yxmrGCHG1iC/CrdyEL34aqT+N1H83I3VONq2Wd7xH",
	"vcUKRqgsQKDjspI1efkKvaFLZppDFrVR5XunFYQXutz2ry42PPwlTDqYS4s5EI7xX+J6U6tdIOnUx/+2",
	"43+66FlWUHwWp/45Mpw+zztHg2l7MW1SUEUeFwWYxdqpKpB/KmFM15Am+KOH6gwyfp44/5oTR8v8v955",
	"M33pELouiGJcQ2qastnqyx1IohJooctTQzatpdabACVY0xl1fVcqMs0/dCZU/skSfuFWqg8g/ttPLv7J",
	"xZtwMZqnIMm5Ubzb4hPyyjT5IN3PBEbOL9SAomSBVCLlEOFT1H9BFX3pciTqY/GbqQLTCf3oJoxyWmxs",
	"bovuY3XI/iTRFE6RgjQ4B2JSTVu8EAEdrp6iRgJmvn3/HqWgpcn2C/Oun8rWVI9RRgXPkzGi0Md5VYVw",
	"gPs69w/6uKAfVlCuScRy4aOihVFZ6XAzkasCOpg4yybgAjrog9NY+sET8+5gNM2qcb59//8BAAD//2d/",
	"ittiywAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
